GHSA-9vx8-f5c4-862x

Suggest an improvement
Source
https://github.com/advisories/GHSA-9vx8-f5c4-862x
Import Source
https://github.com/github/advisory-database/blob/main/advisories/github-reviewed/2023/02/GHSA-9vx8-f5c4-862x/GHSA-9vx8-f5c4-862x.json
JSON Data
https://api.osv.dev/v1/vulns/GHSA-9vx8-f5c4-862x
Published
2023-02-24T17:39:18Z
Modified
2023-04-11T01:38:56.882967Z
Severity
  • CVSS_V3 - CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:H
Summary
XML External Entity (XXE) vulnerability in apoc.import.graphml
Details

Impact

A XML External Entity (XXE) vulnerability found in the apoc.import.graphml procedure of APOC core plugin in Neo4j graph database. XML External Entity (XXE) injection occurs when the XML parser allows external entities to be resolved. The XML parser used by the apoc.import.graphml procedure was not configured in a secure way and therefore allowed this.

External entities can be used to read local files, send HTTP requests, and perform denial-of-service attacks on the application.

Abusing the XXE vulnerability enabled assessors to read local files remotely. Although with the level of privileges assessors had this was limited to one-line files. With the ability to write to the database, any file could have been read. Additionally, assessors noted, with local testing, the server could be crashed by passing in improperly formatted XML.

Patches

The users should aim to use the latest released version compatible with their Neo4j version. The minimum versions containing patch for this vulnerability is 4.4.0.14.

Workarounds

If you cannot upgrade the library, you can control the allowlist of the procedures that can be used in your system.

For more information

If you have any questions or comments about this advisory: * Open an issue in neo4j-apoc-procedures * Email us at security@neo4j.com

Credits

We want to publicly recognise the contribution of Christopher Schneider – State Farm.

References

Affected packages

Maven / org.neo4j.procedure:apoc

Package

Name
org.neo4j.procedure:apoc
Purl
pkg:maven/org.neo4j.procedure/apoc

Affected ranges

Type
ECOSYSTEM
Events
Introduced
0The exact introduced commit is unknown
Fixed
4.4.0.14

Affected versions

1.*

1.0.0-RC1
1.0.0
1.1.0

3.*

3.0.4.1
3.0.4.2
3.0.8.4
3.0.8.5
3.1.0.2
3.1.0.3
3.1.0.4
3.1.0.5
3.1.2.5
3.1.3.7
3.1.3.8
3.1.3.9
3.2.0.1
3.2.0.4
3.2.3.5
3.2.3.6
3.3.0.1
3.3.0.2
3.3.0.3
3.3.0.4
3.4.0.1
3.4.0.2
3.4.0.3
3.4.0.4
3.4.0.5
3.4.0.7
3.5.0.1
3.5.0.2
3.5.0.4
3.5.0.5
3.5.0.6
3.5.0.7
3.5.0.10
3.5.0.11
3.5.0.12
3.5.0.13
3.5.0.14
3.5.0.15
3.5.0.17
3.5.0.18
3.5.0.19
3.5.0.20
3.5.0.21

4.*

4.0.0-rc01
4.0.0.0
4.0.0.1
4.0.0.2
4.0.0.5
4.0.0.6
4.0.0.7
4.0.0.8
4.0.0.9
4.0.0.10
4.0.0.11
4.0.0.12
4.0.0.13
4.0.0.14
4.0.0.15
4.0.0.16
4.0.0.17
4.0.0.18
4.1.0.0
4.1.0.1
4.1.0.2
4.1.0.3
4.1.0.4
4.1.0.5
4.1.0.6
4.1.0.7
4.1.0.8
4.1.0.9
4.1.0.10
4.1.0.11
4.1.0.12
4.2.0.0
4.2.0.1
4.2.0.2
4.2.0.3
4.2.0.4
4.2.0.5
4.2.0.6
4.2.0.7
4.2.0.8
4.2.0.9
4.2.0.10
4.2.0.11
4.2.0.12
4.3.0.0
4.3.0.1
4.3.0.2
4.3.0.3
4.3.0.4
4.3.0.5
4.3.0.6
4.3.0.7
4.3.0.8
4.3.0.9
4.3.0.10
4.3.0.11
4.3.0.12
4.4.0.0
4.4.0.1
4.4.0.2
4.4.0.3
4.4.0.4
4.4.0.5
4.4.0.6
4.4.0.7
4.4.0.8
4.4.0.9
4.4.0.10
4.4.0.11
4.4.0.12
4.4.0.13

Maven / org.neo4j.procedure:apoc

Package

Name
org.neo4j.procedure:apoc
Purl
pkg:maven/org.neo4j.procedure/apoc

Affected ranges

Type
ECOSYSTEM
Events
Introduced
5.0.0
Fixed
5.5.0